/**
 * SECTION:DockItem
 * @short_description: The base class for all dock items.
 */
/**
 * PLANK_ITEMS_TYPE_DOCK_ITEM:
 * 
 * The type for <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link>.
 */
/**
 * plank_items_dock_item_handle_deleted:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Signal handler called when the underlying preferences file is deleted.
 */
/**
 * plank_items_dock_item_delete:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Deletes the underlying preferences file.
 */
/**
 * plank_items_dock_item_reset_icon_buffer:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Resets the buffer for this item&apos;s icon and requests a redraw.
 */
/**
 * plank_items_dock_item_reset_buffers:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Resets the buffers for this item&apos;s icon.
 */
/**
 * plank_items_dock_item_get_background_surface:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @draw_func: (in) (allow-none): &nbsp;.  function which creates/changes the background surface 
 * @draw_func_target: (allow-none) (closure): user data to pass to @draw_func
 * 
 * Returns the background surface for this item.
 * 
 * <para>The draw_func may pass through the given previously computed surface or change it as needed. This surface will be buffered internally.</para><para>Passing null as draw_func will destroy the internal background buffer.</para>
 * 
 * Returns: the background surface of this item which may not be changed 
 */
/**
 * plank_items_dock_item_get_foreground_surface:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @draw_func: (in) (allow-none): &nbsp;.  function which creates/changes the foreground surface 
 * @draw_func_target: (allow-none) (closure): user data to pass to @draw_func
 * 
 * Returns the foreground surface for this item.
 * 
 * <para>The draw_func may pass through the given previously computed surface or change it as needed. This surface will be buffered internally.</para><para>Passing null as draw_func will destroy the internal foreground buffer.</para>
 * 
 * Returns: the background surface of this item which may not be changed 
 */
/**
 * plank_items_dock_item_get_surface_copy:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @width: (in): &nbsp;.  width of the icon surface 
 * @height: (in): &nbsp;.  height of the icon surface 
 * @model: (in): &nbsp;.  existing surface to use as basis of new surface 
 * 
 * Returns a copy of the dock surface for this item.
 * 
 * <para>It will trigger an internal redraw if the requested size isn&apos;t matching the cache.</para>
 * 
 * Returns: the copied dock surface for this item 
 */
/**
 * plank_items_dock_item_draw_icon:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @surface: (in): &nbsp;.  the surface to draw on 
 * 
 * Draws the item&apos;s icon onto a surface.
 */
/**
 * plank_items_dock_item_clicked:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @button: (in): &nbsp;.  the button clicked 
 * @mod: (in): &nbsp;.  the modifiers 
 * 
 * Called when an item is clicked on.
 */
/**
 * plank_items_dock_item_on_clicked:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @button: (in): &nbsp;.  the button clicked 
 * @mod: (in): &nbsp;.  the modifiers 
 * 
 * Called when an item is clicked on.
 */
/**
 * plank_items_dock_item_scrolled:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @direction: (in): &nbsp;.  the scroll direction 
 * @mod: (in): &nbsp;.  the modifiers 
 * 
 * Called when an item is scrolled over.
 */
/**
 * plank_items_dock_item_on_scrolled:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @direction: (in): &nbsp;.  the scroll direction 
 * @mod: (in): &nbsp;.  the modifiers 
 * 
 * Called when an item is scrolled over.
 */
/**
 * plank_items_dock_item_get_menu_items:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Returns a list of the item&apos;s menu items.
 * 
 * Returns: the item&apos;s menu items 
 */
/**
 * plank_items_dock_item_can_be_removed:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Returns if this item can be removed from the dock.
 * 
 * Returns: if this item can be removed from the dock 
 */
/**
 * plank_items_dock_item_can_accept_drop:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @uris: (in): &nbsp;.  the URIs to check 
 * 
 * Returns if the item accepts a drop of the given URIs.
 * 
 * Returns: if the item accepts a drop of the given URIs 
 */
/**
 * plank_items_dock_item_accept_drop:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @uris: (in): &nbsp;.  the URIs to accept 
 * 
 * Accepts a drop of the given URIs.
 * 
 * Returns: if the item accepted a drop of the given URIs 
 */
/**
 * plank_items_dock_item_unique_id:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Returns a unique ID for this dock item.
 * 
 * Returns: a unique ID for this dock item 
 */
/**
 * plank_items_dock_item_as_uri:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * 
 * Returns a unique URI for this dock item.
 * 
 * Returns: a unique URI for this dock item 
 */
/**
 * plank_items_dock_item_copy_values_to:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance
 * @target: (in): &nbsp;.  the dockitem to copy the values to 
 * 
 * Copy all property value of this dockitem instance to target instance.
 */
/**
 * plank_items_dock_item_new:
 * 
 * Creates a new dock item.
 */
/**
 * PlankItemsDockItem:Icon:
 * 
 * The dock item&apos;s icon.
 */
/**
 * plank_items_dock_item_get_Icon:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Icon"><type>"Icon"</type></link> property.
 * 
 * The dock item&apos;s icon.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Icon"><type>"Icon"</type></link> property
 */
/**
 * plank_items_dock_item_set_Icon:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Icon"><type>"Icon"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Icon"><type>"Icon"</type></link> property to @value.
 * 
 * The dock item&apos;s icon.
 */
/**
 * PlankItemsDockItem:ForcePixbuf:
 */
/**
 * plank_items_dock_item_get_ForcePixbuf:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--ForcePixbuf"><type>"ForcePixbuf"</type></link> property.
 * 
 * 
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--ForcePixbuf"><type>"ForcePixbuf"</type></link> property
 */
/**
 * plank_items_dock_item_set_ForcePixbuf:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--ForcePixbuf"><type>"ForcePixbuf"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--ForcePixbuf"><type>"ForcePixbuf"</type></link> property to @value.
 * 
 * 
 */
/**
 * PlankItemsDockItem:Text:
 * 
 * The dock item&apos;s text.
 */
/**
 * plank_items_dock_item_get_Text:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Text"><type>"Text"</type></link> property.
 * 
 * The dock item&apos;s text.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Text"><type>"Text"</type></link> property
 */
/**
 * plank_items_dock_item_set_Text:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Text"><type>"Text"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Text"><type>"Text"</type></link> property to @value.
 * 
 * The dock item&apos;s text.
 */
/**
 * PlankItemsDockItem:Count:
 * 
 * The count for the dock item.
 */
/**
 * plank_items_dock_item_get_Count:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Count"><type>"Count"</type></link> property.
 * 
 * The count for the dock item.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Count"><type>"Count"</type></link> property
 */
/**
 * plank_items_dock_item_set_Count:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Count"><type>"Count"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Count"><type>"Count"</type></link> property to @value.
 * 
 * The count for the dock item.
 */
/**
 * PlankItemsDockItem:CountVisible:
 * 
 * Show the item&apos;s count or not.
 */
/**
 * plank_items_dock_item_get_CountVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--CountVisible"><type>"CountVisible"</type></link> property.
 * 
 * Show the item&apos;s count or not.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--CountVisible"><type>"CountVisible"</type></link> property
 */
/**
 * plank_items_dock_item_set_CountVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--CountVisible"><type>"CountVisible"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--CountVisible"><type>"CountVisible"</type></link> property to @value.
 * 
 * Show the item&apos;s count or not.
 */
/**
 * PlankItemsDockItem:Progress:
 * 
 * The progress for this dock item.
 */
/**
 * plank_items_dock_item_get_Progress:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Progress"><type>"Progress"</type></link> property.
 * 
 * The progress for this dock item.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Progress"><type>"Progress"</type></link> property
 */
/**
 * plank_items_dock_item_set_Progress:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Progress"><type>"Progress"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Progress"><type>"Progress"</type></link> property to @value.
 * 
 * The progress for this dock item.
 */
/**
 * PlankItemsDockItem:ProgressVisible:
 * 
 * Show the item&apos;s progress or not.
 */
/**
 * plank_items_dock_item_get_ProgressVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--ProgressVisible"><type>"ProgressVisible"</type></link> property.
 * 
 * Show the item&apos;s progress or not.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--ProgressVisible"><type>"ProgressVisible"</type></link> property
 */
/**
 * plank_items_dock_item_set_ProgressVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--ProgressVisible"><type>"ProgressVisible"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--ProgressVisible"><type>"ProgressVisible"</type></link> property to @value.
 * 
 * Show the item&apos;s progress or not.
 */
/**
 * PlankItemsDockItem:Position:
 * 
 * The dock item&apos;s position on the dock.
 */
/**
 * plank_items_dock_item_get_Position:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Position"><type>"Position"</type></link> property.
 * 
 * The dock item&apos;s position on the dock.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Position"><type>"Position"</type></link> property
 */
/**
 * plank_items_dock_item_set_Position:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Position"><type>"Position"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Position"><type>"Position"</type></link> property to @value.
 * 
 * The dock item&apos;s position on the dock.
 */
/**
 * PlankItemsDockItem:IsVisible:
 * 
 * Wether the item is currently visible on the dock.
 */
/**
 * plank_items_dock_item_get_IsVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--IsVisible"><type>"IsVisible"</type></link> property.
 * 
 * Wether the item is currently visible on the dock.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--IsVisible"><type>"IsVisible"</type></link> property
 */
/**
 * plank_items_dock_item_set_IsVisible:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--IsVisible"><type>"IsVisible"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--IsVisible"><type>"IsVisible"</type></link> property to @value.
 * 
 * Wether the item is currently visible on the dock.
 */
/**
 * PlankItemsDockItem:Button:
 * 
 * The buttons this item shows popup menus for.
 */
/**
 * plank_items_dock_item_get_Button:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Button"><type>"Button"</type></link> property.
 * 
 * The buttons this item shows popup menus for.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Button"><type>"Button"</type></link> property
 */
/**
 * plank_items_dock_item_set_Button:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Button"><type>"Button"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Button"><type>"Button"</type></link> property to @value.
 * 
 * The buttons this item shows popup menus for.
 */
/**
 * PlankItemsDockItem:State:
 * 
 * The item&apos;s current state.
 */
/**
 * plank_items_dock_item_get_State:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--State"><type>"State"</type></link> property.
 * 
 * The item&apos;s current state.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--State"><type>"State"</type></link> property
 */
/**
 * plank_items_dock_item_set_State:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--State"><type>"State"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--State"><type>"State"</type></link> property to @value.
 * 
 * The item&apos;s current state.
 */
/**
 * PlankItemsDockItem:Indicator:
 * 
 * The indicator shown for the item.
 */
/**
 * plank_items_dock_item_get_Indicator:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Indicator"><type>"Indicator"</type></link> property.
 * 
 * The indicator shown for the item.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Indicator"><type>"Indicator"</type></link> property
 */
/**
 * plank_items_dock_item_set_Indicator:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Indicator"><type>"Indicator"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Indicator"><type>"Indicator"</type></link> property to @value.
 * 
 * The indicator shown for the item.
 */
/**
 * PlankItemsDockItem:ClickedAnimation:
 * 
 * The animation to show for the item&apos;s last click event.
 */
/**
 * plank_items_dock_item_get_ClickedAnimation:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--ClickedAnimation"><type>"ClickedAnimation"</type></link> property.
 * 
 * The animation to show for the item&apos;s last click event.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--ClickedAnimation"><type>"ClickedAnimation"</type></link> property
 */
/**
 * plank_items_dock_item_set_ClickedAnimation:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--ClickedAnimation"><type>"ClickedAnimation"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--ClickedAnimation"><type>"ClickedAnimation"</type></link> property to @value.
 * 
 * The animation to show for the item&apos;s last click event.
 */
/**
 * PlankItemsDockItem:AddTime:
 * 
 * The time the item was added to the dock.
 */
/**
 * plank_items_dock_item_get_AddTime:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--AddTime"><type>"AddTime"</type></link> property.
 * 
 * The time the item was added to the dock.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--AddTime"><type>"AddTime"</type></link> property
 */
/**
 * plank_items_dock_item_set_AddTime:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--AddTime"><type>"AddTime"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--AddTime"><type>"AddTime"</type></link> property to @value.
 * 
 * The time the item was added to the dock.
 */
/**
 * PlankItemsDockItem:RemoveTime:
 * 
 * The time the item was removed from the dock.
 */
/**
 * plank_items_dock_item_get_RemoveTime:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--RemoveTime"><type>"RemoveTime"</type></link> property.
 * 
 * The time the item was removed from the dock.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--RemoveTime"><type>"RemoveTime"</type></link> property
 */
/**
 * plank_items_dock_item_set_RemoveTime:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--RemoveTime"><type>"RemoveTime"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--RemoveTime"><type>"RemoveTime"</type></link> property to @value.
 * 
 * The time the item was removed from the dock.
 */
/**
 * PlankItemsDockItem:LastClicked:
 * 
 * The last time the item was clicked.
 */
/**
 * plank_items_dock_item_get_LastClicked:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--LastClicked"><type>"LastClicked"</type></link> property.
 * 
 * The last time the item was clicked.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--LastClicked"><type>"LastClicked"</type></link> property
 */
/**
 * plank_items_dock_item_set_LastClicked:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--LastClicked"><type>"LastClicked"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--LastClicked"><type>"LastClicked"</type></link> property to @value.
 * 
 * The last time the item was clicked.
 */
/**
 * PlankItemsDockItem:LastScrolled:
 * 
 * The last time the item was scrolled.
 */
/**
 * plank_items_dock_item_get_LastScrolled:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--LastScrolled"><type>"LastScrolled"</type></link> property.
 * 
 * The last time the item was scrolled.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--LastScrolled"><type>"LastScrolled"</type></link> property
 */
/**
 * plank_items_dock_item_set_LastScrolled:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--LastScrolled"><type>"LastScrolled"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--LastScrolled"><type>"LastScrolled"</type></link> property to @value.
 * 
 * The last time the item was scrolled.
 */
/**
 * PlankItemsDockItem:LastUrgent:
 * 
 * The last time the item changed its urgent status.
 */
/**
 * plank_items_dock_item_get_LastUrgent:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--LastUrgent"><type>"LastUrgent"</type></link> property.
 * 
 * The last time the item changed its urgent status.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--LastUrgent"><type>"LastUrgent"</type></link> property
 */
/**
 * plank_items_dock_item_set_LastUrgent:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--LastUrgent"><type>"LastUrgent"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--LastUrgent"><type>"LastUrgent"</type></link> property to @value.
 * 
 * The last time the item changed its urgent status.
 */
/**
 * PlankItemsDockItem:LastActive:
 * 
 * The last time the item changed its active status.
 */
/**
 * plank_items_dock_item_get_LastActive:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--LastActive"><type>"LastActive"</type></link> property.
 * 
 * The last time the item changed its active status.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--LastActive"><type>"LastActive"</type></link> property
 */
/**
 * plank_items_dock_item_set_LastActive:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--LastActive"><type>"LastActive"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--LastActive"><type>"LastActive"</type></link> property to @value.
 * 
 * The last time the item changed its active status.
 */
/**
 * PlankItemsDockItem:ValidItem:
 * 
 * Whether or not this item is valid for the .dockitem given.
 */
/**
 * plank_items_dock_item_get_ValidItem:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--ValidItem"><type>"ValidItem"</type></link> property.
 * 
 * Whether or not this item is valid for the .dockitem given.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--ValidItem"><type>"ValidItem"</type></link> property
 */
/**
 * PlankItemsDockItem:AverageIconColor:
 * 
 * The average color of this item&apos;s icon.
 */
/**
 * plank_items_dock_item_get_AverageIconColor:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--AverageIconColor"><type>"AverageIconColor"</type></link> property.
 * 
 * The average color of this item&apos;s icon.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--AverageIconColor"><type>"AverageIconColor"</type></link> property
 */
/**
 * plank_items_dock_item_set_AverageIconColor:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--AverageIconColor"><type>"AverageIconColor"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--AverageIconColor"><type>"AverageIconColor"</type></link> property to @value.
 * 
 * The average color of this item&apos;s icon.
 */
/**
 * PlankItemsDockItem:DockItemFilename:
 * 
 * The filename of the preferences backing file.
 */
/**
 * plank_items_dock_item_get_DockItemFilename:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--DockItemFilename"><type>"DockItemFilename"</type></link> property.
 * 
 * The filename of the preferences backing file.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--DockItemFilename"><type>"DockItemFilename"</type></link> property
 */
/**
 * PlankItemsDockItem:Launcher:
 * 
 * The launcher associated with this item.
 */
/**
 * plank_items_dock_item_get_Launcher:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Launcher"><type>"Launcher"</type></link> property.
 * 
 * The launcher associated with this item.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Launcher"><type>"Launcher"</type></link> property
 */
/**
 * PlankItemsDockItem:Prefs:
 * 
 * The underlying preferences for this item.
 */
/**
 * plank_items_dock_item_get_Prefs:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to query
 * 
 * Get and return the current value of the <link linkend="PlankItemsDockItem--Prefs"><type>"Prefs"</type></link> property.
 * 
 * The underlying preferences for this item.
 * 
 * Returns: the value of the <link linkend="PlankItemsDockItem--Prefs"><type>"Prefs"</type></link> property
 */
/**
 * plank_items_dock_item_set_Prefs:
 * @self: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance to modify
 * @value: the new value of the <link linkend="PlankItemsDockItem--Prefs"><type>"Prefs"</type></link> property
 * 
 * Set the value of the <link linkend="PlankItemsDockItem--Prefs"><type>"Prefs"</type></link> property to @value.
 * 
 * The underlying preferences for this item.
 */
/**
 * PlankItemsDockItem::deleted:
 * @dock_item: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance that received the signal
 * 
 * Signal fired when the .dockitem for this item was deleted.
 */
/**
 * PlankItemsDockItem::launcher-changed:
 * @dock_item: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance that received the signal
 * 
 * Signal fired when the launcher associated with the dock item changed.
 */
/**
 * PlankItemsDockItem::needs-redraw:
 * @dock_item: the <link linkend="PlankItemsDockItem"><type>PlankItemsDockItem</type></link> instance that received the signal
 * 
 * Signal fired when the dock item needs redrawn.
 */
/**
 * plank_items_dock_item_create_menu_item:
 * @title: (in): &nbsp;.  the title of the menu item 
 * @icon: (in): &nbsp;.  the icon of the menu item 
 * 
 * Creates a new menu item.
 * 
 * Returns: the new menu item 
 */
/**
 * PlankItemsDockItem:
 * 
 * The base class for all dock items.
 */
/**
 * PlankItemsDockItemClass:
 * @draw_icon: virtual method used internally
 * @on_clicked: virtual method used internally
 * @on_scrolled: virtual method used internally
 * @get_menu_items: virtual method called by <link linkend="plank-items-dock-item-get-menu-items"><function>plank_items_dock_item_get_menu_items()</function></link>
 * @can_be_removed: virtual method called by <link linkend="plank-items-dock-item-can-be-removed"><function>plank_items_dock_item_can_be_removed()</function></link>
 * @can_accept_drop: virtual method called by <link linkend="plank-items-dock-item-can-accept-drop"><function>plank_items_dock_item_can_accept_drop()</function></link>
 * @accept_drop: virtual method called by <link linkend="plank-items-dock-item-accept-drop"><function>plank_items_dock_item_accept_drop()</function></link>
 * @unique_id: virtual method called by <link linkend="plank-items-dock-item-unique-id"><function>plank_items_dock_item_unique_id()</function></link>
 * @get_ValidItem: getter method for the abstract property <link linkend="PlankItemsDockItem--ValidItem"><type>"ValidItem"</type></link>
 * @parent_class: the parent class structure
 * 
 * The class structure for <link linkend="PLANK-ITEMS-TYPE-DOCK-ITEM:CAPS"><literal>PLANK_ITEMS_TYPE_DOCK_ITEM</literal></link>. All the fields in this structure are private and should never be accessed directly.
 */
/**
 * PlankItemsDrawItemFunc:
 * @item: (in): &nbsp;.  the dock-item 
 * @source: (in): &nbsp;.  original surface which may not be changed 
 * @target: (in) (allow-none): &nbsp;.  the previously modified surface 
 * @user_data: (closure): data to pass to the delegate function
 * 
 * Draws a modified surface onto another newly created or given surface
 * 
 * Returns: the modified surface or passed through target 
 */
/**
 * PlankItemsIndicatorState:
 * @PLANK_ITEMS_INDICATOR_STATE_NONE: None - no windows for this item.
 * @PLANK_ITEMS_INDICATOR_STATE_SINGLE: Show a single indicator - there is 1 window for this item.
 * @PLANK_ITEMS_INDICATOR_STATE_SINGLE_PLUS: Show multiple indicators - there are more than 1 window for this item.
 * 
 * What item indicator to show.
 */
/**
 * PlankItemsItemState:
 * @PLANK_ITEMS_ITEM_STATE_NORMAL: The item is in a normal state.
 * @PLANK_ITEMS_ITEM_STATE_ACTIVE: The item is currently active (a window in the group is focused).
 * @PLANK_ITEMS_ITEM_STATE_URGENT: The item is currently urgent (a window in the group has the urgent flag).
 * 
 * The current activity state of an item. The item has several states to track and can be in any combination of them.
 */
/**
 * PlankItemsClickAnimation:
 * @PLANK_ITEMS_CLICK_ANIMATION_NONE: No animation.
 * @PLANK_ITEMS_CLICK_ANIMATION_BOUNCE: Bounce the icon.
 * @PLANK_ITEMS_CLICK_ANIMATION_DARKEN: Darken the icon, then restore it.
 * @PLANK_ITEMS_CLICK_ANIMATION_LIGHTEN: Brighten the icon, then restore it.
 * 
 * What type of animation to perform when an item is clicked.
 */
/**
 * plank_items_popup_button_from_event_button:
 * @event: (in): &nbsp;.  the event to map 
 * 
 * Convenience method to map <link linkend="GdkEventButton"><type>GdkEventButton</type></link> to this enum.
 * 
 * Returns: the PopupButton representation of the event 
 */
/**
 * PlankItemsPopupButton:
 * @PLANK_ITEMS_POPUP_BUTTON_NONE: No button pops up the context.
 * @PLANK_ITEMS_POPUP_BUTTON_LEFT: Left button pops up the context.
 * @PLANK_ITEMS_POPUP_BUTTON_MIDDLE: Middle button pops up the context.
 * @PLANK_ITEMS_POPUP_BUTTON_RIGHT: Right button pops up the context.
 * 
 * What mouse button pops up the context menu on an item. Can be multiple buttons.
 */
